#include <pthread.h>
#include <stdio.h>

#include <unistd.h>

pthread_cond_t c1;
pthread_mutex_t m1;

void* foo(void* data)
{
	int ret;
	/* OK, 0 */
	ret = pthread_mutex_lock(&m1);		printf("%d\n", ret);
	printf("waiting\n");
	/* OK, 0 */
	ret = pthread_cond_wait(&c1, &m1);	printf("%d\n", ret);
	printf("Sleeping in foo()\n");
	sleep(3);
	/* OK, 0 */
	printf("foo finished\n");
}

/*
Should write:
0
22
0
22
0
0
0
Sleeping in main()
0
waiting
signaling
0
Sleeping in main()
0
Sleeping in foo()
0
main finished
foo finished
*/

int
main()
{
	int ret;
	
	/* OK, 0 */
	ret = pthread_cond_init(&c1, NULL);	printf("%d\n", ret);
	/* Init again, EINVAL */
	ret = pthread_cond_init(&c1, NULL);	printf("%d\n", ret);

	/* OK, 0 */
	ret = pthread_cond_destroy(&c1);	printf("%d\n", ret);

	/* Again, EINVAL */
	ret = pthread_cond_destroy(&c1);	printf("%d\n", ret);

	/* OK, 0 */
	ret = pthread_cond_init(&c1, NULL);	printf("%d\n", ret);
	/* OK, 0 */
	ret = pthread_mutex_init(&m1, NULL); printf("%d\n", ret);

	/* OK, 0 */
	//ret = pthread_mutex_lock(&m1);		printf("%d\n", ret);

	pthread_t t1;
	/* OK, 0 */
	ret = pthread_create(&t1, NULL, foo, NULL); printf("%d\n", ret);
	

	printf("Sleeping in main()\n");
	sleep(1);

	/* OK, 0 */
	printf("signaling\n");
	ret = pthread_cond_signal(&c1); printf("%d\n", ret);
	
	/* After pthrad_cond_wait() in foo(), EBUSY */
	//ret = pthread_cond_destroy(&c1);	printf("%d\n", ret);

	printf("Sleeping in main()\n");
	sleep(2);
	
	/* After pthread_cond_signal() in foo() OK, 0 */
	ret = pthread_cond_destroy(&c1);		printf("%d\n", ret);

	printf("main finished\n");
}
