/** datarace.c
 * This tests file illustrates the detection of data concurrency errors by GMC. 
 * Running it in interpretation mode will succeed (the accesses to variable i
 * will be in correct order). In model checker mode, both orders of accesses
 * to i will be tried, therefore one of the assertions will fail.
 */

#include <pthread.h>
#include <stdio.h>
#include <assert.h>

// Global variable accessed by both main thread and thread t1.
int i = 0;

void* thread1(void* data)
{
	i += 1;
	// This thread requires to be
	// the second to access the variable.
	assert(i == 2);
}
int main()
{
	pthread_t t1;
	pthread_create(&t1, NULL, thread1, NULL);
	i += 1;
	// This thread requires to be the first
	// to access the variable.
	assert(i == 1);
	pthread_join(t1, NULL);
	printf("%s\n", "OK!");
	return 0;
}
