/** threads.c
 * This test demonstates bakctracking of GMC - each thread accesses global
 * variable i, which results in a huge number of possible schedulings of
 * the threads.
 */

#include <pthread.h>
#include <stdio.h>
#include <stdlib.h>
#define NUM_THREADS     1

int i = 0;

void *PrintHello(void *threadid)
{
   printf("In thread t1: 1, i: %d\n", i);
   i += 1;
}

void *PrintHello2(void *threadid)
{
   printf("In thread t2: 1, i: %d\n", i);
   i += 1;
}

void *PrintHello3(void *threadid)
{
   printf("In thread t3: 1, i: %d\n", i);
   i += 1;
}

int main (int argc, char *argv[])
{
	pthread_mutex_t m1;
	pthread_mutex_init(&m1, NULL);
	pthread_t t1, t2, t3;
	printf("In main: creating thread!\n");
	pthread_create(&t1, NULL, PrintHello, NULL);
	pthread_create(&t2, NULL, PrintHello2, NULL);
	pthread_create(&t3, NULL, PrintHello3, NULL);
	printf("In main: 1, i: %d\n", i);
	i += 1;
	pthread_join(t1, NULL);
	pthread_join(t2, NULL);
	pthread_join(t3, NULL);
}
