#!/bin/bash

TESTSPATH=errortests
GIMPLEXX_FILE="gimplexx.ser"

find $TESTSPATH/*.c > testsout

count=0
succ=0
fail=0
#start_time=$(date +%s)

clean(){
	rm -f $GIMPLEXX_FILE
	rm -f tmptest
	rm -f tmptest_output
	rm -f gmc_output
	rm -f diff_output
	rm -f testsout
	rm -f testsout2
}


while read line
do
	sources="$line"
        count=`expr $count + 1`;
	echo -n "Testing file" $count ": " $line "..."
	
	make out clean "SOURCES=$sources" "GIMPLEXX_FILE=$GIMPLEXX_FILE" > makeout 2> makeout

	if [ $? != 0 ]
	then
		echo "make failed, see 'makeout' for more details."
		continue;
	fi

	./ModelChecker -i $GIMPLEXX_FILE > gmc_output 2> mcout

	if [ $? != 0 ]
	then
		fail=`expr $fail + 1`;
		echo "failed."
		echo "----------------------"
		echo "See file 'mcout' for ModelChecker output."
		#cat mcout
		echo "----------------------"
		continue
		#exit 1
	else
		rm -f mcout

		diff "$line.output" gmc_output > diff_output

		if [[ -s diff_output ]]
		then
			fail=`expr $fail + 1`;
			echo "failed."
			echo "----------------------"
			echo "Desired output:"
			cat "$line.output"
			echo "----------------------"
			echo "GMC output:"
			cat gmc_output
			echo "----------------------"
		else
			succ=`expr $succ + 1`;
			echo "OK."
		fi
	fi

	clean

done < "testsout"

#finish_time=$(date +%s)
#echo "Time duration: $((finish_time - start_time)) secs"

echo "SUMMARY:"
echo "  SUCCESFUL: $succ of $count"
echo "  FAILED: $fail of $count"
