#!/bin/bash

TESTSPATH=tests
GIMPLEXX_FILE="gimplexx.ser"

find $TESTSPATH/* -maxdepth 0 > testsout

count=0
succ=0
fail=0
#start_time=$(date +%s)

clean(){
	#rm -f gimplexx.ser
	rm -f makeout
	rm -f tmptest
	rm -f tmptest_output
	rm -f gmc_output
	rm -f diff_output
	rm -f $TESTSPATH/*.o
	rm -f $TESTSPATH/*.P
	rm -f testsout
	rm -f testsout2
}


while read line
do
	sources=""
	if [ -d $line ]
	then
		what="directory"
		
		find $line/*.c > testout2
		while read line2
		do
			sources="$sources $line2"
		done < "testout2"
	else
		what="file"
		sources="$line"
		#continue
	fi

        count=`expr $count + 1`;
	echo -n "Testing $what" $count ": " $line "..."
	
	make out clean "SOURCES=$sources" "GIMPLEXX_FILE=$GIMPLEXX_FILE"> makeout 2> makeout
	
	if [ $? == 0 ]
	then
		if [ -d $line ]
		then
			current_dir=`pwd`
			cd "$line"
			make > /dev/null
			cd "$current_dir"
		else
			gcc -otmptest $line
		fi
		
		./tmptest > tmptest_output
		./ModelChecker -i $GIMPLEXX_FILE > gmc_output 2> mcout

		if [ $? != 0 ]
		then
			fail=`expr $fail + 1`;
			echo "failed."
			echo "----------------------"
			echo "See file 'mcout' for ModelChecker output."
			#cat mcout
			echo "----------------------"
			continue
			#exit 1
		else
			rm -f mcout

			diff tmptest_output gmc_output > diff_output

			if [[ -s diff_output ]]
			then
				fail=`expr $fail + 1`;
				echo "failed."
				echo "----------------------"
				echo "Original output:"
				cat tmptest_output
				echo "----------------------"
				echo "GMC output:"
				cat gmc_output
				echo "----------------------"
			else
				succ=`expr $succ + 1`;
				echo "OK."
			fi
		fi
	else
		fail=`expr $fail + 1`;
		"failed build."
		echo "----------------------"
		echo "Make output:"
		cat makeout
		echo "----------------------"
	fi

	clean

done < "testsout"

#finish_time=$(date +%s)
#echo "Time duration: $((finish_time - start_time)) secs"

echo "SUMMARY:"
echo "  SUCCESFUL: $succ of $count"
echo "  FAILED: $fail of $count"
