// 
// GMC Gimple Model Checker
// Copyright (C) 2009-2011 GMC team
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as 
// published by the Free Software Foundation, either version 3 of 
// the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.

// You should have received a copy of the GNU Lesser General Public 
// License along with this program.  
// If not, see <http://www.gnu.org/licenses/>.

/** @file CTypes.h
 * Typedefs for classes from namespace giterator to be used in C.
 */
#ifndef GIT_C_TYPES_H
#define GIT_C_TYPES_H

#ifdef __cplusplus
extern "C" {
namespace giterator { 
#endif
    
/** @name GIT classes for C
 * Definition types, that allow to use pointers to @c giterator classes in C code.
 */
/*@{*/
typedef struct FunctionDecl* git_function_decl;
typedef struct Function* git_function;
typedef struct Block* git_block;
typedef struct Type* git_type;
typedef struct Decl* git_decl;
typedef struct Stmt* git_stmt;
typedef struct Operand* git_operand;
typedef struct Operation* git_operation;
typedef struct Edge* git_edge;
typedef struct Constant* git_constant;

typedef const struct FunctionDecl* const_git_function_decl;
typedef const struct Function* const_git_function;
typedef const struct Block* const_git_block;
typedef const struct Type* const_git_type;
typedef const struct Decl* const_git_decl;
typedef const struct Constant* const_git_constant;

typedef struct Gimple* git_gimple;
typedef struct GimpleHelpers* git_gimple_helpers;
typedef struct FunctionHelpers* git_function_helpers;
/*@}*/

#ifdef __cplusplus
}
}
#endif

#endif /* GIT_C_TYPES_H */

