// 
// GMC Gimple Model Checker
// Copyright (C) 2009-2011 GMC team
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as 
// published by the Free Software Foundation, either version 3 of 
// the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.

// You should have received a copy of the GNU Lesser General Public 
// License along with this program.  
// If not, see <http://www.gnu.org/licenses/>.

/** @file GccBridge.h
 * This file contains declarations of functions and macro definitions that 
 * are used in @c Gimple class to access the information in GIMPLE representation.
 * 
 * @see Gimple
 */

#ifndef GIT_GCC_BRIDGE_H
#define GIT_GCC_BRIDGE_H

#include "CTypes.h"

   
#ifdef __cplusplus
#include "gimple_types.h"

extern "C" {
namespace giterator { namespace detail {
#endif

extern void gb_process_cfun (void);
extern git_gimple gb_get_construction_result (void);
extern void gb_end_construction (void);
extern const_git_type gb_get_bool_type (git_gimple gim, git_gimple_helpers gim_help);
extern const_git_type gb_get_void_ptr_type (git_gimple gim, git_gimple_helpers gim_help);

extern struct varpool_node* gb_varpool_nodes (void);
extern struct varpool_node* gb_varpool_next (struct varpool_node* vn);
extern const_git_decl gb_varpool_decl (git_gimple gim, git_gimple_helpers gim_help, struct varpool_node* vn);

#ifdef __cplusplus
}}
}
#endif


#define GB_FOR_EACH_GLOBAL_VAR(gim, decl, vn) \
for ((vn) = giterator::detail::gb_varpool_nodes (), (decl) =    \
                giterator::detail::gb_varpool_decl (gim, vn); \
     (vn); (vn) = giterator::detail::gb_varpool_next (vn),  \
           (decl) = giterator::detail::gb_varpool_decl (gim, vn))

#endif /* GIT_GCC_BRIDGE_H */
