// 
// GMC Gimple Model Checker
// Copyright (C) 2009-2011 GMC team
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as 
// published by the Free Software Foundation, either version 3 of 
// the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.

// You should have received a copy of the GNU Lesser General Public 
// License along with this program.  
// If not, see <http://www.gnu.org/licenses/>.

/** @file Operations_fwd.h
 * This file contains forward definitions of classes 
 * representing GIMPLE++ operations.
 */
#ifndef GIT_OPERATION_SFWD_H
#define GIT_OPERATIONS_FWD_H

namespace giterator { namespace detail {

struct UnaryOperationImpl;
struct BinaryOperationImpl;

}

struct NegateOperation;
struct AbsOperation;
struct FixTruncOperation;
struct FloatOperation;
struct BitNotOperation;
struct TruthNotOperation;
struct ParenOperation;
struct NonLvalueOperation;
struct NoOperation;
struct ConvertOperation;
struct PlusOperation;
struct MinusOperation;
struct MultOperation;
struct RdivOperation;
struct TruncDivOperation;
struct FloorDivOperation;
struct CeilDivOperation;
struct RoundDivOperation;
struct TruncModOperation;
struct FloorModOperation;
struct CeilModOperation;
struct RoundModOperation;
struct ExactDivOperation;
struct MinOperation;
struct MaxOperation;
struct LshiftOperation;
struct RshiftOperation;
struct LrotateOperation;
struct RrotateOperation;
struct BitIorOperation;
struct BitXorOperation;
struct BitAndOperation;
struct TruthAndOperation;
struct TruthOrOperation;
struct TruthXorOperation;
struct LtOperation;
struct LeOperation;
struct GtOperation;
struct GeOperation;
struct EqOperation;
struct NeOperation;
struct OrderedOperation;
struct UnorderedOperation;
struct UnLtOperation;
struct UnLeOperation;
struct UnGtOperation;
struct UnGeOperation;
struct UnEqOperation;
struct LtGtOperation;
struct WidenSumOperation;
struct WidenMultOperation;

}

#endif /* GIT_OPERATIONS_FWD_H */
