// 
// GMC Gimple Model Checker
// Copyright (C) 2009-2011 GMC team
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as 
// published by the Free Software Foundation, either version 3 of 
// the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.

// You should have received a copy of the GNU Lesser General Public 
// License along with this program.  
// If not, see <http://www.gnu.org/licenses/>.

/** @file TreeProduct.h
 * Common super-class of all classes, that represent information obtained
 * from GIMPLE's tree.
 */
#ifndef GIT_TREE_PRODUCT_H
#define GIT_TREE_PRODUCT_H

namespace giterator { namespace detail {
    
/**
 * Common super-class of all classes, that represent information obtained 
 * from GIMPLE <tt>struct tree</tt>.
 * All of the classes Constant, Decl, Type are subclasses of this class.
 */
struct TreeProduct {
    virtual ~TreeProduct () {}

    /**
     * Serialize this class - flattens if into a sequence
     * of characters or bits and stores them in a file
     * that can be later turned back to the original object
     * (deserialized).
     * @tparam a type of a serialization archive
     * @param the archive to serialize the class to
     * @param class version information
     */
    template<class Archive>
	void serialize(Archive &, const unsigned int) {}
};

}}

#endif /* GIT_TREE_PRODUCT_H */
