// 
// GMC Gimple Model Checker
// Copyright (C) 2009-2011 GMC team
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as 
// published by the Free Software Foundation, either version 3 of 
// the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.

// You should have received a copy of the GNU Lesser General Public 
// License along with this program.  
// If not, see <http://www.gnu.org/licenses/>.

/** @file gimple_types.h
 * This file contains forward declarations of few types defined in GIMPLE,
 * so they can be used also in C++.
 */

#ifndef GIT_GIMPLE_TYPES_H
#define GIT_GIMPLE_TYPES_H

/** @name GIMPLE types for C++
 * Forward declarations, that allow to use pointers to GIMPLE types in C++.
 * It is not possible to include the header files where are these types
 * defined, because it would not compile.
 */
/*@{*/
typedef union tree_node* tree;
typedef struct basic_block_def* basic_block;
struct function;
struct varpool_node;
/*@}*/

#endif /* GIT_GIMPLE_TYPES_H */
