// 
// GMC Gimple Model Checker
// Copyright (C) 2009-2011 GMC team
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as 
// published by the Free Software Foundation, either version 3 of 
// the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.

// You should have received a copy of the GNU Lesser General Public 
// License along with this program.  
// If not, see <http://www.gnu.org/licenses/>.

/** @file git_fwd.h
 * This file contains forward declarations of @c giterator classes.
 */
#ifndef GIT_GIT_FWD_H
#define GIT_GIT_FWD_H

#include "Operations_fwd.h"

namespace giterator {

/** @name Forward declarations from giterator.
 * This file contains forward declarations of classes from namespace @c giterator.
 * Include this file instead of @c Gimple.h, when only declarations of classes are needed.
 */
/*@{*/
class Gimple;

class Function;
class Block;
class Edge;

class Type;
class ArrayType;
class BoolType;
class EnumType;
class FunctionType;
class IntegerType;
class PtrType;
class RealType;
class RecordType;
class VoidType;

class Decl;
class OffsetDecl;
class ConstDecl;
class FieldDecl;
class FunctionDecl;
class LabelDecl;
class ParamDecl;
class ResultDecl;
class TypeDecl;
class VarDecl;
class RecordDecl;

class Constant;
class IntegerConstant;
class EnumeralConstant;
class RealConstant;
class StringConstant;

class Stmt;
class CallStmt;
class ReturnStmt;
class AssignStmt;
class CondStmt;
class LabelStmt;
class GotoStmt;
class NopStmt;
class PhiStmt;
class SwitchStmt;

class Operand;
class ArrayRefOperand;
class ComponentRefOperand;
class LabelExprOperand;
class CstOperand;
class DeclOperand;
class ConstructorOperand;
class AddrOperand;
class IndirectRefOperand;
class ArrayConstructorOperand;
class RecordConstructorOperand;

namespace detail {
    
class AbstractDecl;
class AbstractType;
class DecoratingOperand;
class TypeOperand;
template <typename Key, typename Value> class ObjectCache;
class TreeProduct;
/*@}*/
}

}

#endif /* GIT_GIT_FWD_H */
