// 
// GMC Gimple Model Checker
// Copyright (C) 2009-2011 GMC team
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as 
// published by the Free Software Foundation, either version 3 of 
// the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.

// You should have received a copy of the GNU Lesser General Public 
// License along with this program.  
// If not, see <http://www.gnu.org/licenses/>.

/** @file ArrayValue.cpp
 * Definitions for class representing simulated value of an array.
 */
#include "ArrayValue.h"

#include <memory>
#include <boost/functional/hash.hpp>

namespace ginterpreter
{

ArrayValue::ArrayValue(const giterator::Type* type, mmodule::Ptr arrayPtr, size_t size)
: AbstractPtrValue (type), m_ptr(arrayPtr), m_size(size)
{}

Value* ArrayValue::clone () const
{
	return new ArrayValue(getType(), m_ptr, m_size);
}

mmodule::Ptr ArrayValue::getPtr () const
{ return m_ptr; }

size_t ArrayValue::getUnitSize () const
{
	return m_size;
}

}
