// 
// GMC Gimple Model Checker
// Copyright (C) 2009-2011 GMC team
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as 
// published by the Free Software Foundation, either version 3 of 
// the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.

// You should have received a copy of the GNU Lesser General Public 
// License along with this program.  
// If not, see <http://www.gnu.org/licenses/>.

/** @file ExceptionMessages.h
 * Definition of a messages repotred by exceptions.
 */

#ifndef INT_EXCEPTION_MESSAGES_H
#define INT_EXCEPTION_MESSAGES_H

#define OUTPUT_SEPARATOR "*********\n"

#define FREED_AREA_ACCESS_EXC_MSG "An attempt to access an already freed memory area was made."
#define NULL_POINTER_EXC_MSG "An attempt to access null pointer was made."
#define NOT_AREA_BEGIN_EXC_MSG "Pointer does not point to the beginning of an memory area (but it should)."
#define UNDEFINED_MEMORY_LOAD_EXC_MSG "An undefined memory load was made. Probably an uninitialized variable was used or a part of an initialized variable was overwritten."
#define OUT_OF_BOUNDS_EXC_MSG "An attempt to access beyond a memory area was made. (For example access beyond the size of an array)."
#define UNDEFINED_PTR_OPERATION_EXC_MSG "Undefined pointer operation was made (For example increasing pointer by a constant that causes the pointer to point outside the memory area)."
#define ABORT_EXC_MSG "Builtin function abort was called, causing program termination."
#define ASSERT_EXC_MSG "Assertion failed. The assertion was:\n"
#define INVALID_PTR_EXC_MSG "Invalid pointer conversion occured."
#define OVERLAPPING_AREAS_EXC_MSG "Two areas that should not overlap do overlap (in either memcpy() or strcpy() fucntion)"
#define DEADLOCK_EXC_MSG "Deadlock occurred."

#define UNREACHABLE_AREA_MSG "An unreachable area was detected. Probably a unfreed pointer was rewritten."


#endif /* INT_EXCEPTION_MESSAGES_H */
