// 
// GMC Gimple Model Checker
// Copyright (C) 2009-2011 GMC team
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as 
// published by the Free Software Foundation, either version 3 of 
// the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.

// You should have received a copy of the GNU Lesser General Public 
// License along with this program.  
// If not, see <http://www.gnu.org/licenses/>.

/** @file OstreamOperators.h
 * Operator for printing mmodule::Ptr values.
 */
#ifndef INT_OSTREAM_OPERATORS_H
#define INT_OSTREAM_OPERATORS_H

#include <ostream>

#include "../mm/Ptr.h"

/**
 * Operator for printing @c mmodule::Ptr values.
 */
inline std::ostream& 
operator<< (std::ostream& os, mmodule::Ptr ptr)
{
    std::ostream workOs (os.rdbuf ());
    workOs << std::hex << std::showbase << ptr.getAreaId ();
    workOs << std::dec << std::noshowbase << ":" << ptr.getOffset ();
    return os;
}
        
#endif /* INT_OSTREAM_OPERATORS_H */
