// 
// GMC Gimple Model Checker
// Copyright (C) 2009-2011 GMC team
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as 
// published by the Free Software Foundation, either version 3 of 
// the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.

// You should have received a copy of the GNU Lesser General Public 
// License along with this program.  
// If not, see <http://www.gnu.org/licenses/>.

/** @file ProgramInfo.h
 * Structure specifying the layout of the values in an area
 * holding information about the program.
 */
#ifndef INT_PROGRAM_INFO_H
#define INT_PROGRAM_INFO_H

#include "ThreadPoolInfo.h"
#include "../mm/Ptr.h"

#include <boost/fusion/adapted/struct/adapt_struct.hpp>


namespace ginterpreter {

class Thread;

/**
 * Structure specifying the layout of the values in an area 
 * holding information about the program.
 */
struct ProgramInfo {
	int stepCount;
    /*! pointer to the beginning of the read only area */
    mmodule::Ptr roAreaPtr;
    /*! pointer to the beginning of the area, where globals are stored */
    mmodule::Ptr globalsAreaPtr;
    /*! reference to the threads of program */
	mmodule::Ref<ThreadPoolInfo> threadPool;
};

}

#endif /* INT_PROGRAM_INFO_H */
