// 
// GMC Gimple Model Checker
// Copyright (C) 2009-2011 GMC team
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as 
// published by the Free Software Foundation, either version 3 of 
// the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.

// You should have received a copy of the GNU Lesser General Public 
// License along with this program.  
// If not, see <http://www.gnu.org/licenses/>.

/** @file RecordValue.cpp
 * Definitions for class representing a simulated struct/union.
 */
#include "RecordValue.h"

#include <boost/functional/hash.hpp>

namespace ginterpreter
{

RecordValue::RecordValue(const giterator::Type* type, mmodule::Ptr recordPtr,
			size_t unitSize, size_t offset)
: AbstractPtrValue (type), m_ptr(recordPtr),
  m_size(unitSize), m_offset(offset)
{}

Value* RecordValue::clone () const
{
	return new RecordValue(getType(), m_ptr, m_size, m_offset);
}

mmodule::Ptr RecordValue::getPtr () const
{ return m_ptr; }

size_t RecordValue::getUnitSize () const
{
	return m_size;
}

size_t RecordValue::getOffset() const
{
	return m_offset;
}

// TODO:
/*
mmodule::Hash getHash () const
{ return boost::hash<mmodule::Ptr> () (m_ptr); }*/
}
