// 
// GMC Gimple Model Checker
// Copyright (C) 2009-2011 GMC team
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as 
// published by the Free Software Foundation, either version 3 of 
// the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.

// You should have received a copy of the GNU Lesser General Public 
// License along with this program.  
// If not, see <http://www.gnu.org/licenses/>.

/** @file RunningMode.h
 * Defines enum of modes in which @c Program class is used.
 */

#ifndef INT_RUNNING_MODE_H
#define INT_RUNNING_MODE_H

namespace ginterpreter
{

/**
 * Modes of use of class @c Program.
 * Currently used only for interpretation of @c sleep()
 * function, which behaves differently in interpreter
 * than in the model checer.
 */
enum RunningMode
{
	MODE_INTERPRETER,		/**< Interpretation mode. */
	MODE_MODELCHECKER		/**< Model checking mode. */
};

}

#endif /* INT_RUNNING_MODE_H */
