// 
// GMC Gimple Model Checker
// Copyright (C) 2009-2011 GMC team
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as 
// published by the Free Software Foundation, either version 3 of 
// the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.

// You should have received a copy of the GNU Lesser General Public 
// License along with this program.  
// If not, see <http://www.gnu.org/licenses/>.

/** @file SimpleInstructionExecutor.h
 * Declaration of a class handling simplest instruction execution during modelchecking.
 */

#ifndef INT_SIMPLE_INSTRUCTION_EXECUTOR_H
#define INT_SIMPLE_INSTRUCTION_EXECUTOR_H

#include "InstructionExecutor.h"

namespace ginterpreter
{

class InstructionLogger;

/**
 * Class handling simplest instruction execution during modelchecking
 * executing a single instruction.
 */
class SimpleInstructionExecutor : public InstructionExecutor
{
public:
	bool execute(Program* program, mmodule::MemoryState* memoryState, InstructionLogger* iLogger) const;
};

}

#endif /* INT_SIMPLE_INSTRUCTION_EXECUTOR_H */
