// 
// GMC Gimple Model Checker
// Copyright (C) 2009-2011 GMC team
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as 
// published by the Free Software Foundation, either version 3 of 
// the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.

// You should have received a copy of the GNU Lesser General Public 
// License along with this program.  
// If not, see <http://www.gnu.org/licenses/>.

/** @file SymbolicPrinter.h
 * Declaration of Printer that prints declaration operands
 * as the value they evaluate to.
 */
#ifndef INT_SYMBOLIC_PRINTER_H
#define INT_SYMBOLIC_PRINTER_H

#include "PrinterBase.h"

namespace ginterpreter {
    
/**
 * Printer that prints declaration operands as the value they evaluate to instead 
 * of printing them symbolicaly.
 */
class SymbolicPrinter : public PrinterBase 
{
  public:
    /**
     * Constructor.
     * 
     * @param os output stream where to print
     */
    SymbolicPrinter (std::ostream& os) : PrinterBase (os) {}
    
    void visit(const giterator::DeclOperand& op);
};

}

#endif /* INT_SYMBOLIC_PRINTER_H */
