// 
// GMC Gimple Model Checker
// Copyright (C) 2009-2011 GMC team
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as 
// published by the Free Software Foundation, either version 3 of 
// the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.

// You should have received a copy of the GNU Lesser General Public 
// License along with this program.  
// If not, see <http://www.gnu.org/licenses/>.

/** @file ThreadState.h
 * Enumeration of all possible states that thread may be in.
 */

#ifndef INT_THREAD_STATE_H
#define INT_THREAD_STATE_H

namespace ginterpreter
{
	/**
	 * Enumeration of all possible states that thread may be in.
	 */
	enum ThreadState
	{
		THREAD_UNSTARTED,			/**< Unused. */
		THREAD_RUNNING,				/**< Thread is currently selected for running. */
		THREAD_STOPPED,				/**< Thread has been terminated. */
		THREAD_WAITLOCK,			/**< Thread is waiting to acquire a lock. */
		THREAD_WAITCOND,			/**< Thread is waiting for a condition. */
		THREAD_SLEEP,				/**< Thread is sleeping. */
		THREAD_JOIN					/**< Thread is waiting for another thread to terminate (join). */
	};
}

#endif /* INT_THREAD_STATE_H */
