// 
// GMC Gimple Model Checker
// Copyright (C) 2009-2011 GMC team
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as 
// published by the Free Software Foundation, either version 3 of 
// the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.

// You should have received a copy of the GNU Lesser General Public 
// License along with this program.  
// If not, see <http://www.gnu.org/licenses/>.

/** @file ThreadsManager.cpp
 * Definitions for class that manages threads in the interpreted program.
 */
#include "ThreadsManager.h"

#include "../mm/MemoryState.h"
#include "../mm/Content.h"

#include <limits>
#include <cassert>

using namespace mmodule;

namespace ginterpreter {

/**
 * Constructor.
 */
ThreadsManager::ThreadsManager (MemoryState* memoryState)
: m_memoryState (memoryState), m_threadPtr()
{
}

Ptr ThreadsManager::getThreadPtr (Thread::ID ID) const
{
	/* TODO:
	ThreadPtrs::const_iterator it = m_threadPtrs.find (ID);

	if (it != m_threadPtrs.end ())
		return it->second;
	else
		return Ptr ();
	*/

	return Ptr ();
}

Ptr ThreadsManager::addThreadInfo (Thread::ID ID, Ref<ThreadInfo> Info)
{
	/* TODO:
	assert (m_threadPtrs.find (ID) == m_threadPtrs.end ());

	Ptr valPtr = m_memoryState->alloc(ID->getType()->getUnitSize());
	m_threadPtrs.insert (std::make_pair (ID, valPtr));

	return valPtr;
	*/

	return Ptr ();
}

Ptr ThreadsManager::getThreadPtr () const
{
	assert (m_threadPtr.isNull());
	return m_threadPtr;
}

}
