// 
// GMC Gimple Model Checker
// Copyright (C) 2009-2011 GMC team
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as 
// published by the Free Software Foundation, either version 3 of 
// the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.

// You should have received a copy of the GNU Lesser General Public 
// License along with this program.  
// If not, see <http://www.gnu.org/licenses/>.

/* @file UidResolver.h
 * Declaration of a class for resolving ID's of operands.
 */

#ifndef INT_UIDRESOLVER_H
#define INT_UIDRESOLVER_H

#include "../git/Operand.h"

namespace ginterpreter
{

class UidResolver : public giterator::Operand::Visitor
{
public:
	typedef unsigned int ID;
private:
	ID m_uid;
public:
	UidResolver();

	ID getUid() const;

	void visit (const giterator::AddrOperand&);
	void visit (const giterator::DeclOperand&);
	void visit (const giterator::LabelExprOperand&);
	void visit (const giterator::IndirectRefOperand&);
	void visit (const giterator::ArrayRefOperand&);
	void visit (const giterator::ComponentRefOperand&);
	void visit (const giterator::CstOperand&);
	void visit (const giterator::ArrayConstructorOperand&);
	void visit (const giterator::RecordConstructorOperand&);
};

}

#endif /* INT_UIDRESOLVER_H */
