// 
// GMC Gimple Model Checker
// Copyright (C) 2009-2011 GMC team
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as 
// published by the Free Software Foundation, either version 3 of 
// the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.

// You should have received a copy of the GNU Lesser General Public 
// License along with this program.  
// If not, see <http://www.gnu.org/licenses/>.

#ifndef MM_TYPES_H
#define MM_TYPES_H

#include <stdint.h>

namespace mmodule {

/**
 * Type for memory state hash.
 */
typedef uint32_t Hash;


namespace detail {

#define CANON_UNREACHABLE 0

/**
 * Type for canonical address.
 */
typedef uint32_t CanonAddr;


/**
 * Type big enough to hold the result of multiplication of two @c Hash values.
 */
typedef uint64_t MultHash;


/**
 * Returns big prime number that fits into @c Hash.
 * 
 * @return big prime number that fits into @c Hash
 */
inline Hash
hashModul () 
{
    // 64-bit: 18446744073709551557
    return 4294967291u;
}

}
}

#endif
