// 
// GMC Gimple Model Checker
// Copyright (C) 2009-2011 GMC team
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as 
// published by the Free Software Foundation, either version 3 of 
// the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.

// You should have received a copy of the GNU Lesser General Public 
// License along with this program.  
// If not, see <http://www.gnu.org/licenses/>.

#ifndef ADDCONTENTUNDO_H
#define	ADDCONTENTUNDO_H

#include "ContentUndo.h"

namespace mmodule { namespace detail {

/**
 * A @c ContentUndo that can revert addition of a content of a memory area.
 * The corresponding @c ContentEntry is owned by this object and it is
 * deallocated on destruction.
 */
class AddContentUndo : public ContentUndo {
public:
    AddContentUndo(AreaEntry* area, ContentEntry* content);
    virtual ~AddContentUndo();

    virtual void undo(State& state);
private:

};

}}

#endif	/* ADDCONTENTUNDO_H */

