// 
// GMC Gimple Model Checker
// Copyright (C) 2009-2011 GMC team
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as 
// published by the Free Software Foundation, either version 3 of 
// the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.

// You should have received a copy of the GNU Lesser General Public 
// License along with this program.  
// If not, see <http://www.gnu.org/licenses/>.

#include "../../Error.h"
#include "RemoveContentUndo.h"
#include "../RefContentEntry.h"
#include "../AreaEntry.h"

using namespace mmodule::detail;

RemoveContentUndo::RemoveContentUndo(AreaEntry* area, ContentEntry* content) :
ContentUndo(area, content) {
}

void
RemoveContentUndo::undo(State& state) {
    LOG_DEBUG ("Undoing RemoveContent");

    RefContentEntry* rce = dynamic_cast<RefContentEntry*> (m_content);
    if (rce && rce->isValidLink() && rce->getSource() != rce->getTarget()) {
        rce->addLink();
    }

    m_area->unremoveContent(m_content);
}
