// 
// GMC Gimple Model Checker
// Copyright (C) 2009-2011 GMC team
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as 
// published by the Free Software Foundation, either version 3 of 
// the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.

// You should have received a copy of the GNU Lesser General Public 
// License along with this program.  
// If not, see <http://www.gnu.org/licenses/>.

/*
 * File:   MemoryStateTest.h
 * Author: sery
 *
 * Created on Jul 8, 2010, 10:14:38 AM
 */

#ifndef MEMORYSTATETEST_H
#define	MEMORYSTATETEST_H

#include <cppunit/extensions/HelperMacros.h>

class MemoryStateTest : public CPPUNIT_NS::TestFixture {
    CPPUNIT_TEST_SUITE(MemoryStateTest);

    CPPUNIT_TEST(testMS01_Alloc);
    CPPUNIT_TEST(testMS02_Store);
    CPPUNIT_TEST(testMS03_StoreLoad);
    CPPUNIT_TEST(testMS04_HashTest);
    CPPUNIT_TEST(testMS05_Backtrack);

    CPPUNIT_TEST_SUITE_END();

public:
    MemoryStateTest();
    virtual ~MemoryStateTest();
    void setUp();
    void tearDown();

private:
    void testMS01_Alloc();
    void testMS02_Store();
    void testMS03_StoreLoad();
    void testMS04_HashTest();
    void testMS05_Backtrack();
};

#endif	/* MEMORYSTATETEST_H */

